//+------------------------------------------------------------------+
//|                                                 Seneca Pilot.mq4 |
//|                                   Copyright 2012, Lonnie Coffman |
//|                                          dropshipsites@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Lonnie Coffman (lcoff on FF)"
#property link      "dropshipsites@gmail.com"

extern string Trade_Settings = "---TRADE SETTINGS--------------------";
extern int    MagicNumber = 89881;
extern int    ATR_Target = 20; //15, 20 or 25
extern double RiskPercentPerTrade = 2;   // risk percent per trade
extern double FreeMarginPercent = 15;      // percent of margin to remain unused.
extern string General_Settings = "---GENERAL SETTINGS--------------------";
extern string GMTOpenHour = "4";
extern bool   TwoBarsBetweenTrades = true;
extern bool   Use_London_Close = true;
extern bool   CombineSundayMonday = true;
extern bool   Draw_Day_Start_Line = true;
extern bool   Erase_Lines_on_Close = true;
extern int    Extend_Bars_Past_Present = 10;
extern int    Number_of_Figure_Lines = 5; // number of big figure and mid figure lines to show above/below price
extern string Line_Properties =  "---LINE PROPERTIES--------------------";
extern string Line_Properties1 = "Style: 0=Solid, 1=Dash, 2=Dot,";
extern string Line_Properties2 = "          3=DashDot, 4=DashDotDot";
extern string Line_Properties3 = "-------------------------------------------------------";
extern string Past_Levels_Label = "Past Levels";
extern bool   Past_Levels_Active = false;
extern int    Past_Levels_Width = 1;
extern int    Past_Levels_Style = STYLE_DOT;
extern color  Past_Levels_Color = PowderBlue;
extern string Big_Figure_Label = "Big Figure";
extern bool   Big_Figure_Active = true;
extern int    Big_Figure_Width = 1;
extern int    Big_Figure_Style = STYLE_DOT;
extern color  Big_Figure_Color = C'40,40,40';
extern string Mid_Figure_Label = "Mid Figure";
extern bool   Mid_Figure_Active = true;
extern int    Mid_Figure_Width = 1;
extern int    Mid_Figure_Style = STYLE_DOT;
extern color  Mid_Figure_Color = C'40,40,40';
extern string Previous_Week_High_Label = "Previous Week High";
extern bool   Previous_Week_High_Active = true;
extern int    Previous_Week_High_Width = 1;
extern int    Previous_Week_High_Style = STYLE_SOLID;
extern color  Previous_Week_High_Color = Purple;
extern string Previous_Week_Low_Label = "Previous Week Low";
extern bool   Previous_Week_Low_Active = true;
extern int    Previous_Week_Low_Width = 1;
extern int    Previous_Week_Low_Style = STYLE_SOLID;
extern color  Previous_Week_Low_Color = Purple;
extern string Previous_Week_Close_Label = "Previous Week Close";
extern bool   Previous_Week_Close_Active = true;
extern int    Previous_Week_Close_Width = 1;
extern int    Previous_Week_Close_Style = STYLE_SOLID;
extern color  Previous_Week_Close_Color = Purple;
extern string Daily_Open_Label = "Daily Open";
extern bool   Daily_Open_Active = true;
extern int    Daily_Open_Width = 1;
extern int    Daily_Open_Style = STYLE_SOLID;
extern color  Daily_Open_Color = Green;
extern string Previous_Day_Open_Label = "Previous Day Open";
extern bool   Previous_Day_Open_Active = true;
extern int    Previous_Day_Open_Width = 1;
extern int    Previous_Day_Open_Style = STYLE_SOLID;
extern color  Previous_Day_Open_Color = Green;
extern string Previous_Day_Low_Label = "Previous Day Low";
extern bool   Previous_Day_Low_Active = true;
extern int    Previous_Day_Low_Width = 1;
extern int    Previous_Day_Low_Style = STYLE_SOLID;
extern color  Previous_Day_Low_Color = Green;
extern string Previous_Day_High_Label = "Previous Day High";
extern bool   Previous_Day_High_Active = true;
extern int    Previous_Day_High_Width = 1;
extern int    Previous_Day_High_Style = STYLE_SOLID;
extern color  Previous_Day_High_Color = Green;
extern string Previous_London_Close_Label  = "London Close";
extern int    Previous_London_Close_Width  = 1;
extern int    Previous_London_Close_Style  = STYLE_DOT;
extern color  Previous_London_Close_Color  = DarkGoldenrod;
extern string Beginning_of_Day_Label  = "Beginning of Day";
extern bool   Beginning_of_Day_Active = true;
extern int    Beginning_of_Day_Width  = 1;
extern int    Beginning_of_Day_Style  = STYLE_SOLID;
extern color  Beginning_of_Day_Color  = DarkOliveGreen;
int a;
int Threshold = 5;

double BeginningOfDayData[2];
double DailyOpenData[2];
double PreviousDayOpenData[2];
double PreviousDayHighData[2];
double PreviousDayLowData[2];
double PreviousWeekHighData[2];
double PreviousWeekLowData[2];
double PreviousWeekOpenData[2];
double PreviousWeekCloseData[2];
double LondonCloseData[2];
double PastLevels[4];

double Percent15, Percent20, Percent25;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      // remove all levels
      if (Erase_Lines_on_Close == true){
         a = 1;
         ObjectDelete(Mid_Figure_Label+" 0");
         while(a <= (Number_of_Figure_Lines * 2)){
            ObjectDelete(Big_Figure_Label+" "+DoubleToStr(a,0));
            ObjectDelete(Mid_Figure_Label+" "+DoubleToStr(a,0));
            a++;
         }
         a = 0;
         while(a <= 3){
            ObjectDelete(Past_Levels_Label+" "+DoubleToStr(a,0));
            a++;
         }
         ObjectDelete(Previous_Week_High_Label);
         ObjectDelete(Previous_Week_Low_Label);
         ObjectDelete(Previous_Week_Close_Label);
         ObjectDelete(Daily_Open_Label);
         ObjectDelete(Previous_Day_Open_Label);
         ObjectDelete(Previous_Day_Low_Label);
         ObjectDelete(Previous_Day_High_Label);
         ObjectDelete(Previous_London_Close_Label);
         ObjectDelete(Beginning_of_Day_Label);
         ObjectDelete("Start of Previous Day");
         ObjectDelete("Start of Previous Week");
         ObjectDelete("End of Previous Week");
         ObjectDelete("ATR15");
         ObjectDelete("ATR20");
         ObjectDelete("ATR25");
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   string Pair = Symbol();
   int Timeframe = Period();
   int ExtendBars = (Time[0] + (Extend_Bars_Past_Present * 60 * Period()));
   bool ActiveOrder = false;
   bool PendingOrder = false;
   string ActiveOrderType,PendingOrderType;
   int ActiveOrderNumber,PendingOrderNumber,RawLevel,Slippage,TicketNumber,RoundValue,ATRValue;
   double UpperLevel,LowerLevel;
   double TakeProfit,StopLoss,Entry,LotSize;
   bool EnterLong, EnterShort;
   bool FailedLong, FailedShort;
   
   double Levels[11];
   ArrayInitialize(Levels,0);
   
   // Get Weekly and Daily Levels
   CalculateLevels(Pair,Timeframe);
   // Get Past SR lines
   GetPastLevels(Pair,BeginningOfDayData[0],DailyOpenData[1]);
   
   if (Draw_Day_Start_Line == true){       DrawLine(Pair, OBJ_VLINE, Beginning_of_Day_Label, BeginningOfDayData[0], 0, 0, 0, Beginning_of_Day_Style, Beginning_of_Day_Color, Beginning_of_Day_Width);
                                           DrawLine(Pair, OBJ_VLINE, "Start of Previous Day", PreviousDayOpenData[0], 0, 0, 0, Previous_Day_Open_Style, Beginning_of_Day_Color, Previous_Day_Open_Width);
                                           DrawLine(Pair, OBJ_VLINE, "Start of Previous Week", PreviousWeekOpenData[0], 0, 0, 0, Previous_Week_Close_Style, Previous_Week_Close_Color, Previous_Week_Close_Width);
                                           DrawLine(Pair, OBJ_VLINE, "End of Previous Week", PreviousWeekCloseData[0], 0, 0, 0, Previous_Week_Close_Style, Previous_Week_Close_Color, Previous_Week_Close_Width);
   
   }
   if (Daily_Open_Active == true)          DrawLine(Pair, OBJ_TREND, Daily_Open_Label, DailyOpenData[0], DailyOpenData[1], ExtendBars, DailyOpenData[1], Daily_Open_Style, Daily_Open_Color, Daily_Open_Width);
   if (Previous_Day_High_Active == true)   DrawLine(Pair, OBJ_TREND, Previous_Day_High_Label, PreviousDayHighData[0], PreviousDayHighData[1], ExtendBars, PreviousDayHighData[1], Previous_Day_High_Style, Previous_Day_High_Color, Previous_Day_High_Width);
   if (Previous_Day_Low_Active == true)    DrawLine(Pair, OBJ_TREND, Previous_Day_Low_Label, PreviousDayLowData[0], PreviousDayLowData[1], ExtendBars, PreviousDayLowData[1], Previous_Day_Low_Style, Previous_Day_Low_Color, Previous_Day_Low_Width);
   if (Previous_Week_Close_Active == true) DrawLine(Pair, OBJ_TREND, Previous_Week_Close_Label, PreviousWeekCloseData[0], PreviousWeekCloseData[1], ExtendBars, PreviousWeekCloseData[1], Previous_Week_Close_Style, Previous_Week_Close_Color, Previous_Week_Close_Width);
   if (Previous_Week_High_Active == true)  DrawLine(Pair, OBJ_TREND, Previous_Week_High_Label, PreviousWeekHighData[0], PreviousWeekHighData[1], ExtendBars, PreviousWeekHighData[1], Previous_Week_High_Style, Previous_Week_High_Color, Previous_Week_High_Width);
   if (Previous_Week_Low_Active == true)   DrawLine(Pair, OBJ_TREND, Previous_Week_Low_Label, PreviousWeekLowData[0], PreviousWeekLowData[1], ExtendBars, PreviousWeekLowData[1], Previous_Week_Low_Style, Previous_Week_Low_Color, Previous_Week_Low_Width);
   if (Use_London_Close == true)           DrawLine(Pair, OBJ_TREND, Previous_London_Close_Label, LondonCloseData[0]-1, LondonCloseData[1], ExtendBars, LondonCloseData[1], Previous_London_Close_Style, Previous_London_Close_Color, Previous_London_Close_Width);
   if (Past_Levels_Active == true){
                                           DrawLine(Pair, OBJ_TREND, Past_Levels_Label+" 0", BeginningOfDayData[0], PastLevels[0], ExtendBars, PastLevels[0], Past_Levels_Style, Past_Levels_Color, Past_Levels_Width);
                                           DrawLine(Pair, OBJ_TREND, Past_Levels_Label+" 1", BeginningOfDayData[0], PastLevels[1], ExtendBars, PastLevels[1], Past_Levels_Style, Past_Levels_Color, Past_Levels_Width);
                                           DrawLine(Pair, OBJ_TREND, Past_Levels_Label+" 2", BeginningOfDayData[0], PastLevels[2], ExtendBars, PastLevels[2], Past_Levels_Style, Past_Levels_Color, Past_Levels_Width);
                                           DrawLine(Pair, OBJ_TREND, Past_Levels_Label+" 3", BeginningOfDayData[0], PastLevels[3], ExtendBars, PastLevels[3], Past_Levels_Style, Past_Levels_Color, Past_Levels_Width);
   }
   // Draw figure lines
   if ((Number_of_Figure_Lines > 0)&&((Big_Figure_Active == true)||(Mid_Figure_Active == true))){
      DrawFigures(Pair, Number_of_Figure_Lines);
   }
   
   
   
   // Display ATR Calculations
   DisplayATR(Pair);
   
   // is there an open order?
   for(a=0; a<OrdersTotal(); a++){
      if(OrderSelect(a,SELECT_BY_POS) == true){
         if (OrderMagicNumber() == MagicNumber){
            if(OrderSymbol() == Pair){
               if (OrderType() == OP_BUY){ // there is an active order
                  ActiveOrder = true;
                  ActiveOrderType = "buy";
                  ActiveOrderNumber = OrderTicket();
               }
               if (OrderType() == OP_SELL){
                  ActiveOrder = true;
                  ActiveOrderType = "sell";
                  ActiveOrderNumber = OrderTicket();
               }
               if (OrderType() == OP_BUYSTOP){ // there is a pending order 
                  PendingOrder = true;
                  PendingOrderType = "buy";
                  PendingOrderNumber = OrderTicket();
               }
               if (OrderType() == OP_SELLSTOP){
                  PendingOrder = true;
                  PendingOrderType = "sell";
                  PendingOrderNumber = OrderTicket();
               }
               // if the market is about to close, close all trades regardless of p/l
               if ((TimeDayOfWeek(TimeCurrent()) == 5) && (TimeHour(TimeCurrent()) >= 17)){
                  if (OrderType() == OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,3);
                  if (OrderType() == OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,3);
               }
               // if sell order and within 1 pip of target close trade.
               if (OrderType() == OP_SELL){
                  if (MarketInfo(Pair, MODE_BID) <= OrderTakeProfit()+(1 * PipPoint(Pair))){
                     OrderClose(OrderTicket(),OrderLots(),Ask,3);
                  }
               }
               // if buy order and within 1 pip of target close trade.
               if (OrderType() == OP_BUY){
                  if (MarketInfo(Pair, MODE_ASK) >= OrderTakeProfit()-(1 * PipPoint(Pair))){
                     OrderClose(OrderTicket(),OrderLots(),Bid,3);
                  }
               }
            }
         }
      }
   }
   
   FailedLong = false;
   FailedShort = false;
   
   // was last trade stopped out on previous bar?  if so allow for trade in opposite direction.
   for(a=0; a<OrdersHistoryTotal(); a++){
      if(OrderSelect(a,SELECT_BY_POS,MODE_HISTORY) == true){
         if ( (OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Pair) ){
            // if profit is negative and order closed on previous bar look for opposite trade.
            if ((OrderProfit() < 0)&&(iBarShift(Pair,PERIOD_M15,OrderCloseTime()) == 1)&&(iBarShift(Pair,PERIOD_M15,OrderOpenTime()) <= 3)){
               if (OrderType() == OP_BUY) FailedLong = true;
               if (OrderType() == OP_SELL) FailedShort = true;
            }
         }
      } 
   }
   
   // what levels is price near?
   if (Daily_Open_Active == true)         Levels[0] = DailyOpenData[1];
   if (Previous_Day_High_Active == true)  Levels[1] = PreviousDayHighData[1];
   if (Previous_Day_Low_Active == true)   Levels[2] = PreviousDayLowData[1];
   if (Previous_Week_Close_Active == true)Levels[3] = PreviousWeekCloseData[1];
   if (Previous_Week_High_Active == true) Levels[4] = PreviousWeekHighData[1];
   if (Previous_Week_Low_Active == true)  Levels[5] = PreviousWeekLowData[1];
   if (Use_London_Close == true)          Levels[6] = LondonCloseData[1];
   if (Past_Levels_Active == true){
                                          Levels[7] = PastLevels[0];
                                          Levels[8] = PastLevels[1];
                                          Levels[9] = PastLevels[2];
                                          Levels[10] = PastLevels[3];
   }
   ArraySort(Levels);

   double BidPrice = MarketInfo(Pair, MODE_BID);

   RawLevel = ArrayBsearch(Levels, BidPrice);
   if (RawLevel == 0){
      if (Levels[RawLevel] > BidPrice){
         LowerLevel = 0;
         UpperLevel = Levels[RawLevel];
      } else {
         LowerLevel = Levels[RawLevel];
         UpperLevel = Levels[RawLevel + 1];
      }
   } else if (RawLevel == ArraySize(Levels)){
      LowerLevel = Levels[RawLevel];
      UpperLevel = 0;
   } else {
      LowerLevel = Levels[RawLevel];
      UpperLevel = Levels[RawLevel + 1];
   }
   
   // Do not look for trades on Friday after 11:00 GMT
   if ((TimeDayOfWeek(TimeCurrent()) == 5) && (TimeHour(TimeCurrent()) >= 12)) ActiveOrder = true;
   
   // look for new trades
   if (ActiveOrder == false){
      
      EnterShort = false;
      EnterLong = false;
      
      // is price touching level (1 pip gap).  Use bid not ask.
      if ((LowerLevel > 0)&&(NormalizeDouble((BidPrice - LowerLevel)/PipPoint(Pair),1)) <= 1){
         // short. Has price been below LowerLevel for 30 mins?
         if (TwoBarsBetweenTrades == true){
            if (iHigh(Pair,PERIOD_M15,iHighest(Pair,PERIOD_M15,MODE_HIGH,2,1)) <= LowerLevel){
               EnterShort = true;
            }
         } else {
            if (iHigh(Pair,PERIOD_M1,iHighest(Pair,PERIOD_M1,MODE_HIGH,28,2)) <= LowerLevel){
               EnterShort = true;
            }
         }
         if (FailedLong == true) EnterShort = true;
      } else if ((UpperLevel > 0)&&(NormalizeDouble((UpperLevel - BidPrice)/PipPoint(Pair),1) <= 1)){
         // long. Has price been above UpperLevel for 30 mins?
         if (TwoBarsBetweenTrades == true){
            if (iLow(Pair,PERIOD_M15,iLowest(Pair,PERIOD_M15,MODE_LOW,2,1)) >= UpperLevel){
               EnterLong = true;
            }
         } else {
            if (iLow(Pair,PERIOD_M1,iLowest(Pair,PERIOD_M1,MODE_LOW,28,2)) >= UpperLevel){
               EnterLong = true;
            }
         }
         if (FailedShort == true) EnterLong = true;
      }
      
      if (ATR_Target == 20){
         ATRValue = Percent20;
      } else if (ATR_Target == 25){
         ATRValue = Percent25;
      } else {
         ATRValue = Percent15;
      }
         
      if (EnterShort == true){
         if (MarketInfo(Pair, MODE_DIGITS) == 5){
            RoundValue = 10000;
         } else {
            RoundValue = 100;
         }
         Levels[0] = MathFloor(Levels[0]*RoundValue)/RoundValue;
         Levels[1] = MathFloor(Levels[1]*RoundValue)/RoundValue;
         Levels[2] = MathFloor(Levels[2]*RoundValue)/RoundValue;
         Levels[3] = MathFloor(Levels[3]*RoundValue)/RoundValue;
         Levels[4] = MathFloor(Levels[4]*RoundValue)/RoundValue;
         Levels[5] = MathFloor(Levels[5]*RoundValue)/RoundValue;
         Levels[6] = MathFloor(Levels[6]*RoundValue)/RoundValue;
         Levels[7] = MathFloor(Levels[7]*RoundValue)/RoundValue;
         Levels[8] = MathFloor(Levels[8]*RoundValue)/RoundValue;
         Levels[9] = MathFloor(Levels[9]*RoundValue)/RoundValue;
         Levels[10] = MathFloor(Levels[10]*RoundValue)/RoundValue;

         // where should take profit be located? If there is a level between Percent15 and Percent30 use it instead.
         if ((Levels[RawLevel - 1] > 0)&&(Levels[RawLevel - 1] < (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 1] > (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel - 1];
         } else if ((Levels[RawLevel - 2] > 0)&&(Levels[RawLevel - 2] < (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 2] > (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel - 2];
         } else if ((Levels[RawLevel - 3] > 0)&&(Levels[RawLevel - 3] < (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 3] > (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel - 3];
         } else if ((Levels[RawLevel - 4] > 0)&&(Levels[RawLevel - 4] < (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 4] > (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel - 4];
         } else {
            TakeProfit = (BidPrice - (ATRValue*2)*PipPoint(Pair));
         }
         // where should stoploss be located? If there is a level within 2 pips of stop use it + 2 pips instead.
         if ((Levels[RawLevel] > 0)&&(Levels[RawLevel] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel] < (BidPrice + ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel] + (2*PipPoint(Pair));
         } else if ((Levels[RawLevel + 1] > 0)&&(Levels[RawLevel + 1] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 1] < (BidPrice + ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel + 1] + (2*PipPoint(Pair));
         } else if ((Levels[RawLevel + 2] > 0)&&(Levels[RawLevel + 2] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 2] < (BidPrice + ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel + 2] + (2*PipPoint(Pair));
         } else if ((Levels[RawLevel + 3] > 0)&&(Levels[RawLevel + 3] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 3] < (BidPrice + ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel + 3] + (2*PipPoint(Pair));
         } else {
            StopLoss = BidPrice + (ATRValue*PipPoint(Pair));
         }
         Entry = BidPrice;
         LotSize = GetLotSize (Pair, RiskPercentPerTrade, ((StopLoss - Entry) / PipPoint(Pair)));
         Slippage = GetSlippage(Pair, 3);
         if ((AccountFreeMargin() - CalculateMarginToOpen(Pair, LotSize)) >= (AccountMargin() * (FreeMarginPercent / 100))){ // is there enough free margin to place trade?
            TicketNumber = OrderSend(Pair, OP_SELL, LotSize, MarketInfo(Pair, MODE_BID), Slippage, 0, 0, NULL, MagicNumber,0,CLR_NONE);
            if ((TicketNumber > 0) && (OrderSelect(TicketNumber, SELECT_BY_TICKET)==true)){
               OrderModify(TicketNumber, OrderOpenPrice(), StopLoss, TakeProfit, 0);
            } else {
               Print("Error: "+GetLastError());
            }
         }
      } else if (EnterLong == true){
         if (MarketInfo(Pair, MODE_DIGITS) == 5){
            RoundValue = 10000;
         } else {
            RoundValue = 100;
         }
         Levels[0] = MathCeil(Levels[0]*RoundValue)/RoundValue;
         Levels[1] = MathCeil(Levels[1]*RoundValue)/RoundValue;
         Levels[2] = MathCeil(Levels[2]*RoundValue)/RoundValue;
         Levels[3] = MathCeil(Levels[3]*RoundValue)/RoundValue;
         Levels[4] = MathCeil(Levels[4]*RoundValue)/RoundValue;
         Levels[5] = MathCeil(Levels[5]*RoundValue)/RoundValue;
         Levels[6] = MathCeil(Levels[6]*RoundValue)/RoundValue;
         Levels[7] = MathCeil(Levels[7]*RoundValue)/RoundValue;
         Levels[8] = MathCeil(Levels[8]*RoundValue)/RoundValue;
         Levels[9] = MathCeil(Levels[9]*RoundValue)/RoundValue;
         Levels[10] = MathCeil(Levels[10]*RoundValue)/RoundValue;
         
         // where should take profit be located? If there is a level between Percent15 and Percent30 use it instead.
         if ((Levels[RawLevel + 2] > 0)&&(Levels[RawLevel + 2] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 2] < (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel + 2];
         } else if ((Levels[RawLevel + 3] > 0)&&(Levels[RawLevel + 3] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 3] < (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel + 3];
         } else if ((Levels[RawLevel + 4] > 0)&&(Levels[RawLevel + 4] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 4] < (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel + 4];
         } else if ((Levels[RawLevel + 5] > 0)&&(Levels[RawLevel + 5] > (BidPrice + (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel + 5] < (BidPrice + ((ATRValue*2)*PipPoint(Pair))))){
            TakeProfit = Levels[RawLevel + 5];
         } else {
            TakeProfit = (BidPrice + (ATRValue*2)*PipPoint(Pair));
         }
         // where should stoploss be located? If there is a level within 2 pips of stop use it + 2 pips instead.
         if ((Levels[RawLevel] > 0)&&(Levels[RawLevel] < (BidPrice - (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel] > (BidPrice - ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel] - (2*PipPoint(Pair));
         } else if ((Levels[RawLevel - 1] > 0)&&(Levels[RawLevel - 1] < (BidPrice - (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 1] > (BidPrice - ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel - 1] - (2*PipPoint(Pair));
         } else if ((Levels[RawLevel - 2] > 0)&&(Levels[RawLevel - 2] < (BidPrice - (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 2] > (BidPrice - ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel - 2] - (2*PipPoint(Pair));
         } else if ((Levels[RawLevel - 3] > 0)&&(Levels[RawLevel - 3] < (BidPrice - (ATRValue*PipPoint(Pair))))&&(Levels[RawLevel - 3] > (BidPrice - ((ATRValue + 2)*PipPoint(Pair))))){
            StopLoss = Levels[RawLevel - 3] - (2*PipPoint(Pair));
         } else {
            StopLoss = BidPrice - (ATRValue*PipPoint(Pair));
         }
         Entry = BidPrice;
         LotSize = GetLotSize (Pair, RiskPercentPerTrade, ((Entry - StopLoss) / PipPoint(Pair)));
         Slippage = GetSlippage(Pair, 3);
         if ((AccountFreeMargin() - CalculateMarginToOpen(Pair, LotSize)) >= (AccountMargin() * (FreeMarginPercent / 100))){ // is there enough free margin to place trade?
            TicketNumber = OrderSend(Pair, OP_BUY, LotSize, MarketInfo(Pair, MODE_ASK), Slippage, 0, 0, NULL, MagicNumber,0,CLR_NONE);
            if ((TicketNumber > 0) && (OrderSelect(TicketNumber, SELECT_BY_TICKET)==true)){
               OrderModify(TicketNumber, OrderOpenPrice(), StopLoss, TakeProfit, 0);
            } else {
               Print("Error: "+GetLastError());
            }
         }
      }
   }
   
   if (EnterLong == true) Print("EnterLong: "+Pair+"|Ent:"+NormalizeDouble(BidPrice,5)+"|Stp:"+NormalizeDouble(StopLoss,5)+"|TP:"+NormalizeDouble(TakeProfit,5)+" @ "+TimeToStr(TimeCurrent()));
   if (EnterShort == true) Print("EnterShort: "+Pair+"|Ent:"+NormalizeDouble(BidPrice,5)+"|Stp:"+NormalizeDouble(StopLoss,5)+"|TP:"+NormalizeDouble(TakeProfit,5)+" @ "+TimeToStr(TimeCurrent()));
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------+//
//| Calculate pip point for pair             |//
//+------------------------------------------+//
double PipPoint(string Pair){
   double GetDigits = MarketInfo(Pair, MODE_DIGITS);
   double UsePoint;
   if(GetDigits == 2 || GetDigits == 3) UsePoint = 0.01;
   else if(GetDigits == 4 || GetDigits == 5) UsePoint = 0.0001;
   return(UsePoint);
}
//+------------------------------------------+//
//| Draw Lines on Chart                      |//
//+------------------------------------------+//
void DrawLine(string Pair, int Type, string Label, datetime Time1, double Price1, datetime Time2, double Price2, int Style, color Color, int Width){
   
   if (ObjectFind(Label) < 0){
      ObjectCreate(Label, Type, 0, Time1, Price1, Time2, Price2);
      ObjectSet(Label, OBJPROP_COLOR, Color);
      ObjectSet(Label, OBJPROP_STYLE, Style);
      ObjectSet(Label, OBJPROP_WIDTH, Width);
      ObjectSet(Label, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);
      if (Type == OBJ_TREND){
         ObjectSetText(Label, "Price: "+DoubleToStr(Price1,Digits), 10);
         ObjectSet(Label, OBJPROP_RAY, false);
      }
   } else {
      if ((Type == OBJ_TREND)||(Type == OBJ_HLINE)){
         if ( (ObjectGet(Label, OBJPROP_PRICE1) != Price1) || (ObjectGet(Label, OBJPROP_PRICE2) != Price2)
               || (ObjectGet(Label, OBJPROP_TIME1) != Time1) || (ObjectGet(Label, OBJPROP_TIME2) != Time2) ){
            ObjectSet(Label, OBJPROP_PRICE1, Price1);
            ObjectSet(Label, OBJPROP_PRICE2, Price2);
            ObjectSet(Label, OBJPROP_TIME1, Time1);
            ObjectSet(Label, OBJPROP_TIME2, Time2);
         }
      }
      if (Type == OBJ_VLINE){
         if (ObjectGet(Label, OBJPROP_TIME1) != Time1){
            ObjectSet(Label, OBJPROP_TIME1, Time1);
         }
      }
   }
}
//+------------------------------------------+//
//| Calculate Values for Lines and Time      |//
//+------------------------------------------+//
void CalculateLevels(string Pair,int Timeframe){

   int BeginningOfDayBar,DailyOpenBar, StartBar, EndBar, HighBar, LowBar, DayNumber, BarNumber, BarHour;
   int CurrentDayOfWeek = TimeDayOfWeek(TimeCurrent());
   int CurrentHour = TimeHour(TimeCurrent());
   int CurrentMinute = TimeMinute(TimeCurrent());
   string CurrentDate = TimeYear(TimeCurrent())+"."+TimeMonth(TimeCurrent())+"."+TimeDay(TimeCurrent());
   
   // get beginning of Day
   BeginningOfDayBar = StrToTime(CurrentDate+" "+GMTOpenHour+":00");
   while (iBarShift(Pair,Timeframe,BeginningOfDayBar,true) < 0){ // Bar does not exist.  Use previous day.
      BeginningOfDayBar = BeginningOfDayBar - 86400;
   }
   
   // get beginning of Previous Day
   int PreviousDayBar = BeginningOfDayBar - 86400;
   while (iBarShift(Pair,Timeframe,PreviousDayBar,true) < 0){ // Bar does not exist.  Use previous day.
      PreviousDayBar = PreviousDayBar - 86400;
   }

   // get beginning of Previous Week.  if GMT < 22 use Sunday else use Monday.
   datetime PreviousWeekBegin = iTime(Pair,PERIOD_W1,1)+86400;
   string PreviousWeekBeginTime = TimeYear(PreviousWeekBegin)+"."+TimeMonth(PreviousWeekBegin)+"."+TimeDay(PreviousWeekBegin);
   datetime PreviousWeekBeginBar = StrToTime(PreviousWeekBeginTime+" "+GMTOpenHour+":00");
   int PreviousWeekEndBar = PreviousWeekBeginBar + 601200;

   BeginningOfDayData[0] = BeginningOfDayBar;
   BeginningOfDayData[1] = 0;
   
   // get daily Open
   DailyOpenData[0] = BeginningOfDayBar;
   DailyOpenData[1] = iOpen(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,BeginningOfDayBar));
   
   // get previous daily Open
   PreviousDayOpenData[0] = PreviousDayBar;
   PreviousDayOpenData[1] = iOpen(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,PreviousDayBar));
   
   // get previous day High/Low
   EndBar = iBarShift(Pair,PERIOD_M1,PreviousDayBar);
   StartBar = iBarShift(Pair,PERIOD_M1,BeginningOfDayBar);
   
   HighBar = iHighest(Pair,PERIOD_M1,MODE_HIGH,EndBar - StartBar,StartBar);
   LowBar = iLowest(Pair,PERIOD_M1,MODE_LOW,EndBar - StartBar,StartBar);
   PreviousDayHighData[0] = iTime(Pair,PERIOD_M1,HighBar);
   PreviousDayHighData[1] = iHigh(Pair,PERIOD_M1,HighBar);
   PreviousDayLowData[0] = iTime(Pair,PERIOD_M1,LowBar);
   PreviousDayLowData[1] = iLow(Pair,PERIOD_M1,LowBar);
   
   // get previous week Close

   PreviousWeekCloseData[0] = PreviousWeekEndBar+3600;
   PreviousWeekCloseData[1] = iClose(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,PreviousWeekEndBar));
   
   // get previous week Open
   PreviousWeekOpenData[0] = PreviousWeekBeginBar;
   PreviousWeekOpenData[1] = iClose(Pair,PERIOD_H1,iBarShift(Pair,PERIOD_H1,PreviousWeekBeginBar));
   
   // get previous week high/low 
   EndBar = iBarShift(Pair,PERIOD_M1,PreviousWeekBeginBar);
   StartBar = iBarShift(Pair,PERIOD_M1,PreviousWeekEndBar);
   
   HighBar = iHighest(Pair,PERIOD_M1,MODE_HIGH,EndBar - StartBar,StartBar);
   LowBar = iLowest(Pair,PERIOD_M1,MODE_LOW,EndBar - StartBar,StartBar);
   PreviousWeekHighData[0] = iTime(Pair,PERIOD_M1,HighBar);
   PreviousWeekHighData[1] = iHigh(Pair,PERIOD_M1,HighBar);
   PreviousWeekLowData[0] = iTime(Pair,PERIOD_M1,LowBar);
   PreviousWeekLowData[1] = iLow(Pair,PERIOD_M1,LowBar);
   
   // get london Close
   int LondonCloseTime = StrToTime(CurrentDate+" 17:00");
   while (iBarShift(Pair,PERIOD_H1,LondonCloseTime) < 0){
      LondonCloseTime = LondonCloseTime - 86400;
   }
   LondonCloseData[0] = LondonCloseTime;
   LondonCloseData[1] = iClose(Pair,PERIOD_H1,(iBarShift(Pair,PERIOD_H1,LondonCloseTime-3600)));
   
   return;
}
//+------------------------------------------+//
//| Draw Big and Mid Figures                 |//
//+------------------------------------------+//
void DrawFigures(string Pair, int NumberFigs){
   double Multiplier,UpperMid,LowerMid,UpperBig,LowerBig;
   double GetDigits = MarketInfo(Pair, MODE_DIGITS);
   if ((GetDigits == 2)||(GetDigits == 3)) Multiplier = 1;
   if ((GetDigits == 4)||(GetDigits == 5)) Multiplier = 100;

   double BigFigUpper = MathCeil(MarketInfo(Pair, MODE_BID) * Multiplier)/Multiplier;
   double BigFigLower = MathFloor(MarketInfo(Pair, MODE_BID) * Multiplier)/Multiplier;
   double MidFigStart = BigFigUpper - (PipPoint(Pair) * 50);
   
   if (Mid_Figure_Active == true){
      DrawLine(Pair, OBJ_HLINE, Mid_Figure_Label+" 0", 0, MidFigStart, 0, 0, Mid_Figure_Style, Mid_Figure_Color, Mid_Figure_Width);
   }
   
   UpperMid = MidFigStart;
   LowerMid = MidFigStart;
   UpperBig = BigFigUpper;
   LowerBig = BigFigLower;
   int a = 0;
   int MidCounter = 1;
   int BigCounter = 1;
   while (a <= NumberFigs){
      UpperMid = UpperMid + (PipPoint(Pair) * 100);
      LowerMid = LowerMid - (PipPoint(Pair) * 100);
      if (Big_Figure_Active == true){
         DrawLine(Pair, OBJ_HLINE, Big_Figure_Label+" "+BigCounter, 0, UpperBig, 0, 0, Big_Figure_Style, Big_Figure_Color, Big_Figure_Width);
         BigCounter++;
         DrawLine(Pair, OBJ_HLINE, Big_Figure_Label+" "+BigCounter, 0, LowerBig, 0, 0, Big_Figure_Style, Big_Figure_Color, Big_Figure_Width);
         BigCounter++;
      }
      if (Mid_Figure_Active == true){
         DrawLine(Pair, OBJ_HLINE, Mid_Figure_Label+" "+MidCounter, 0, UpperMid, 0, 0, Mid_Figure_Style, Mid_Figure_Color, Mid_Figure_Width);
         MidCounter++;
         DrawLine(Pair, OBJ_HLINE, Mid_Figure_Label+" "+MidCounter, 0, LowerMid, 0, 0, Mid_Figure_Style, Mid_Figure_Color, Mid_Figure_Width);
         MidCounter++;
      }
      UpperBig = UpperBig + (PipPoint(Pair) * 100);
      LowerBig = LowerBig - (PipPoint(Pair) * 100);
      a++;
   }
   return;
}
//+------------------------------------------+//
//| Calculate 15%, 20% & 25% of ATR w/ema    |//
//+------------------------------------------+//
void DisplayATR(string Pair){

   string Zero15 = "";
   string Zero20 = "";
   string Zero25 = "";
   
   double ATR1 = iATR(Pair, PERIOD_D1, 5, 0);
   double ATR2 = iATR(Pair, PERIOD_D1, 5, 1);
   double ATR3 = iATR(Pair, PERIOD_D1, 5, 2);
   double ATR4 = iATR(Pair, PERIOD_D1, 5, 3);
   double ATR5 = iATR(Pair, PERIOD_D1, 5, 4);
   double ATR6 = iATR(Pair, PERIOD_D1, 5, 5);
   
   double SMA = (ATR2+ATR3+ATR4+ATR5+ATR6)/5;
   double SMA1 = (ATR1+ATR2+ATR3+ATR4+ATR5)/5;
   double Multiplier = 2.0 / 6;
   double EMA = ((ATR1 - SMA) * Multiplier + SMA);

   Percent15 = NormalizeDouble(EMA/PipPoint(Pair)*0.15,0);
   if (Percent15 < 10) Zero15 = "0";
   Percent20 = NormalizeDouble(EMA/PipPoint(Pair)*0.20,0);
   if (Percent20 < 10) Zero20 = "0";
   Percent25 = NormalizeDouble(EMA/PipPoint(Pair)*0.25,0);
   if (Percent25 < 10) Zero25 = "0";
   
   ObjectCreate("ATR15", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ATR15", "ATR15: "+Zero15+DoubleToStr(Percent15,0), 10, "Courier New", White);
   ObjectSet("ATR15", OBJPROP_CORNER, 1 );
   ObjectSet("ATR15", OBJPROP_XDISTANCE, 14 );
   ObjectSet("ATR15", OBJPROP_YDISTANCE, 46 );
   ObjectSet("ATR15", OBJPROP_BACK, False );
   ObjectCreate("ATR20", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ATR20", "ATR20: "+Zero20+DoubleToStr(Percent20,0), 10, "Courier New", White);
   ObjectSet("ATR20", OBJPROP_CORNER, 1 );
   ObjectSet("ATR20", OBJPROP_XDISTANCE, 14 );
   ObjectSet("ATR20", OBJPROP_YDISTANCE, 60 );
   ObjectSet("ATR20", OBJPROP_BACK, False );
   ObjectCreate("ATR25", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ATR25", "ATR25: "+Zero25+DoubleToStr(Percent25,0), 10, "Courier New", White);
   ObjectSet("ATR25", OBJPROP_CORNER, 1 );
   ObjectSet("ATR25", OBJPROP_XDISTANCE, 14 );
   ObjectSet("ATR25", OBJPROP_YDISTANCE, 74 );
   ObjectSet("ATR25", OBJPROP_BACK, False );
   
   return;
}

//+------------------------------------------+//
//| Get past S/R levels                      |//
//+------------------------------------------+//
void GetPastLevels(string Pair, datetime StartTime, double OpeningPrice){
   
   int UpperLevels[100];
   int Levels[100000];
   ArrayInitialize(Levels,0);
   ArrayInitialize(UpperLevels,0);
   double Multiplier = PipPoint(Pair);
   string StringLevel, RawLevel;
   int BarClose, BarHigh, BarLow;
   
   // one minute
   int CountedBars = 2000;
   int a =  iBarShift(Pair,PERIOD_M1,StartTime);
   int b,c,d,e;
   double Level;
   while (a <= CountedBars){
      BarClose = MathRound(iClose(Pair,PERIOD_M1,a) / Multiplier);
      BarHigh = MathRound(iHigh(Pair,PERIOD_M1,a) / Multiplier);
      BarLow = MathRound(iLow(Pair,PERIOD_M1,a) / Multiplier);
      b = a;
      while (b <= CountedBars){
         Levels[BarClose] = Levels[BarClose] + 1; Levels[BarHigh] = Levels[BarHigh] + 1; Levels[BarLow] = Levels[BarLow] + 1;
         b++;
      }
      a++;
   }
   // five Minute
   CountedBars = 1000;
   a = iBarShift(Pair,PERIOD_M5,StartTime);
   while (a <= CountedBars){
      BarClose = MathRound(iClose(Pair,PERIOD_M5,a) / Multiplier);
      BarHigh = MathRound(iHigh(Pair,PERIOD_M5,a) / Multiplier);
      BarLow = MathRound(iLow(Pair,PERIOD_M5,a) / Multiplier);
      b = a;
      while (b <= CountedBars){
         Levels[BarClose] = Levels[BarClose] + 2; Levels[BarHigh] = Levels[BarHigh] + 2; Levels[BarLow] = Levels[BarLow] + 2;
         b++;
      }
      a++;
   }
   // fifteen Minute
   CountedBars = 800;
   a = iBarShift(Pair,PERIOD_M15,StartTime);
   while (a <= CountedBars){
      BarClose = MathRound(iClose(Pair,PERIOD_M15,a) / Multiplier);
      BarHigh = MathRound(iHigh(Pair,PERIOD_M15,a) / Multiplier);
      BarLow = MathRound(iLow(Pair,PERIOD_M15,a) / Multiplier);
      b = a;
      while (b <= CountedBars){
         Levels[BarClose] = Levels[BarClose] + 3; Levels[BarHigh] = Levels[BarHigh] + 3; Levels[BarLow] = Levels[BarLow] + 3;
         b++;
      }
      a++;
   }

   // Hourly
   CountedBars = 500;
   a = iBarShift(Pair,PERIOD_H1,StartTime);
   while (a <= CountedBars){
      BarClose = MathRound(iClose(Pair,PERIOD_H1,a) / Multiplier);
      BarHigh = MathRound(iHigh(Pair,PERIOD_H1,a) / Multiplier);
      BarLow = MathRound(iLow(Pair,PERIOD_H1,a) / Multiplier);
      b = a;
      while (b <= CountedBars){
         Levels[BarClose] = Levels[BarClose] + 4; Levels[BarHigh] = Levels[BarHigh] + 4; Levels[BarLow] = Levels[BarLow] + 4;
         b++;
      }
      a++;
   }
   // Four Hour
   CountedBars = 200;
   a = iBarShift(Pair,PERIOD_H4,StartTime);
   while (a <= CountedBars){
      BarClose = MathRound(iClose(Pair,PERIOD_H4,a) / Multiplier);
      BarHigh = MathRound(iHigh(Pair,PERIOD_H4,a) / Multiplier);
      BarLow = MathRound(iLow(Pair,PERIOD_H4,a) / Multiplier);
      b = a;
      while (b <= CountedBars){
         Levels[BarClose] = Levels[BarClose] + 5; Levels[BarHigh] = Levels[BarHigh] + 5; Levels[BarLow] = Levels[BarLow] + 5;
         b++;
      }
      a++;
   }
   // Daily
   CountedBars = 100;
   a = iBarShift(Pair,PERIOD_D1,StartTime);
   while (a <= CountedBars){
      BarClose = MathRound(iClose(Pair,PERIOD_D1,a) / Multiplier);
      BarHigh = MathRound(iHigh(Pair,PERIOD_D1,a) / Multiplier);
      BarLow = MathRound(iLow(Pair,PERIOD_D1,a) / Multiplier);
      b = a;
      while (b <= CountedBars){
         Levels[BarClose] = Levels[BarClose] + 6; Levels[BarHigh] = Levels[BarHigh] + 6; Levels[BarLow] = Levels[BarLow] + 6;
         b++;
      }
      a++;
   }

   

   if (MarketInfo(Pair, MODE_DIGITS) == 5){
      c = (OpeningPrice + 0.01) / Multiplier;
      d = (OpeningPrice - 0.01) / Multiplier;
   } else {
      c = (OpeningPrice + 1) / Multiplier;
      d = (OpeningPrice - 1) / Multiplier;
   }
   e = 0;
   while (c > d){
      if (Levels[d] > Threshold){
         UpperLevels[e] = StrToDouble(DoubleToStr(Levels[d],0)+DoubleToStr(d,0));
         e++;
      }
      d++;
   }

   ArraySort(UpperLevels,WHOLE_ARRAY,0,MODE_DESCEND);
   b = 0;
   while (b <= 3){
      StringLevel = DoubleToStr(UpperLevels[b],0);
      if ((Bid < 1)||(MarketInfo(Pair, MODE_DIGITS) == 3)){
         RawLevel = StringSubstr(StringLevel,StringLen(StringLevel)-4,4);
      } else {
         RawLevel = StringSubstr(StringLevel,StringLen(StringLevel)-5,5);
      }
      PastLevels[b] = StrToDouble(RawLevel) * Multiplier;
      b++;
   }
}
//+------------------------------------------+
//| Determine lot size based on defined risk |
//+------------------------------------------+
double GetLotSize ( string pair, double rawrisk, int stopSize )
{
   
   double balance = AccountBalance();
   double pairPrice;
   double usPrice;
   int lotSize;
   double volume;
   double risk = rawrisk * 0.01;
   
   string baseCurrency = StringSubstr(pair,0,3);
   string counterCurrency = StringSubstr(pair,3,3);
   
   if (counterCurrency == "USD") // eg AUDUSDm
   {
      lotSize = balance * risk / stopSize * MarketInfo(pair, MODE_LOTSIZE);
   }
   
   if (baseCurrency == "USD") // eg. USDCADm
   {
      pairPrice = MarketInfo( pair ,MODE_BID);
      lotSize = pairPrice * balance * risk / stopSize * MarketInfo(pair, MODE_LOTSIZE);
   }
   
   if ((counterCurrency != "USD")&&(baseCurrency != "USD"))
   {
      if ((counterCurrency == "CAD") || (counterCurrency == "CHF") || (counterCurrency == "JPY")) // eg. NZDJPYm
      {
         usPrice = MarketInfo( "USD" + counterCurrency + "m" ,MODE_BID);
         lotSize = ((balance * risk) * (usPrice/1)) / stopSize * MarketInfo(pair, MODE_LOTSIZE) / 1;
      }
      else // eg. EURNZDm
      {
         usPrice = MarketInfo( counterCurrency + "USDm" ,MODE_BID);
         lotSize = ((balance * risk) * (1/usPrice)) / stopSize * MarketInfo(pair, MODE_LOTSIZE) / 1;
      }
   }
   
   volume = MathRound(lotSize * 0.01) * 0.01;
   if (counterCurrency == "JPY") volume = MathRound(lotSize * 0.0001) * 0.01; //Account for 3 digits
   
   return (volume);
}
//+------------------------------------------+//
//| Calculate slippage                       |//
//+------------------------------------------+//
int GetSlippage(string Pair, int SlippagePips)
{
   double GetDigits = MarketInfo(Pair, MODE_DIGITS);
   double CalcSlippage;
   if(GetDigits == 2 || GetDigits == 4) CalcSlippage = SlippagePips;
   else if(GetDigits == 3 || GetDigits == 5) CalcSlippage = SlippagePips * 10;
   return(CalcSlippage);
}
//+-----------------------------------+
//| Calculate Margin to open position |
//+-----------------------------------+
double CalculateMarginToOpen(string Pair, double OrderVolume)
  {
      string First    = StringSubstr(Pair,0,3); // the first symbol, for example,  EUR
      string Second   = StringSubstr(Pair,3,3); // the second symbol, for example, USD
      string Currency = AccountCurrency();        // deposit currency, for example,  USD
      double Leverage = AccountLeverage();        // leverage, for example,          100
      double Contract = MarketInfo(Pair, MODE_LOTSIZE);
      double BidPrice = MarketInfo(Pair, MODE_BID);
 
      // USD Base/Quote
      if(First == Currency)
          return(Contract * OrderVolume / Leverage);            // USDxxx

      if(Second == Currency)  
          return(Contract * BidPrice * OrderVolume / Leverage); // xxxUSD

      // CrossPairs
      string Base = Currency + First + "m";                   // USDxxx
      if(MarketInfo(Base, MODE_BID) > 0)
          return(Contract / MarketInfo(Base, MODE_BID) * OrderVolume / Leverage);

      // Not found try inverse
      Base = First + Currency + "m";                          // xxxUSD
      if(MarketInfo(Base, MODE_BID) > 0) 
          return(Contract * MarketInfo(Base, MODE_BID) * OrderVolume / Leverage);

      // Cannot convert
      Print("MarginCalculate: can not convert "+Pair);
      return(0.0);
}